; ---------------------------------------------------------------------------
; Initialize the video system.
;
Videoinit:  Mov   Ax,0013h             ; Select 320x200 with 256 colours
            Int   10h                  
            Mov   Ax,1001h
            Mov   Bh,8
            Int   10h

Setpalette: Push  Ax 
            Push  Bx
            Push  Cx
            Push  Dx
            Push  Es
            Mov   Ax,Cs
            Mov   Es,Ax
            Mov   Bx,10h
            Mov   Ax,1012h
            Mov   Cx,10h
            Mov   Dx,Offset DacArray
            Int   10h
            Mov   Bx,3
@@1:        Mov   Al,[Fs:0D021h+Bx]
            Call  Setpalette1
            Dec   Bl
            Jns   @@1
            Mov   Bl,8
            Mov   Al,[Fs:0D020h]
            Call  Setpalette1
            Pop   Es 
            pop   Dx 
            pop   Cx 
            pop   Bx 
            pop   Ax
            Ret

Setpalette1:Push  Ax 
            push  Bx 
            push  Cx 
            push  Dx
            Mov   Cl,Al
            And   Cl,0Fh
            Cli
            Mov   Dx,3C8h
            Mov   Al,Bl
            Out   (Dx),Al
            Inc   Dx
            Mov   Bl,Cl
            Add   Bl,Bl
            Add   Bl,Cl
            Mov   Al,[DacArray+Bx]
            Out   (Dx),Al
            Mov   Al,[DacArray+Bx+1]
            Out   (Dx),Al
            Mov   Al,[DacArray+Bx+2]
            Out   (Dx),Al
            Sti
            Pop   Dx 
            pop   Cx 
            pop   Bx 
            pop   Ax
            Ret
; ---------------------------------------------------------------------------
Flagrefresh:Mov   [Wantrefresh],1
            Ret
; ---------------------------------------------------------------------------
Refresh:    Pusha
            Push  Ds 
            push  Es 
            push  Fs 
            push  Gs
            ;inc   [byte fs:0d020h]
            Call  Videoremap
            Call  Clearhot
            Call  Sethot
            Call  Snapshot
            Pop   Gs 
            pop   Fs 
            pop   Es 
            pop   Ds
            Popa
            Ret
; ---------------------------------------------------------------------------
Clearhot:   Push  Ds 
            push  Es 
            push  Fs 
            push  Gs
            Mov   Ds,[Layoutseg]
            Mov   Es,[Aramlayout]
            Mov   Fs,[Eramlayout]
            Mov   Gs,[Dramlayout]

            Mov   Di,1000h-4
            Mov   Eax,01010101h*Typ_Norm
            Mov   Bx,4
Align 10h
@@1:        Mov   [   Di       ],Eax
            Mov   [   Di+01000h],Eax
            Mov   [   Di+02000h],Eax
            Mov   [   Di+03000h],Eax
            Mov   [   Di+04000h],Eax
            Mov   [   Di+05000h],Eax
            Mov   [   Di+06000h],Eax
            Mov   [   Di+07000h],Eax
            Mov   [   Di+08000h],Eax
            Mov   [   Di+09000h],Eax
            Mov   [Es:Di+0A000h],Eax
            Mov   [Es:Di+0B000h],Eax
            Mov   [   Di+0C000h],Eax
            Mov   [Gs:Di+0D000h],Eax
            Mov   [Fs:Di+0E000h],Eax
            Mov   [Fs:Di+0F000h],Eax
            Sub   Di,Bx
            Jns   @@1
            Mov   [Byte 1],Typ_0001
            Pop   Gs 
            pop   Fs 
            pop   Es 
            pop   Ds
            Ret
; ---------------------------------------------------------------------------
Sethot:     Push  Ds
            Mov   Cx,[ScreenSize]
            Shr   Cx,2
            Jz    @@1a
            Mov   Ds,[Screenseg]
            Mov   Di,[Screenofs]
            Mov   Eax,01010101h*Typ_Video5
            Mov   [Di+3F8h],Eax
            Mov   [Di+3FCh],Eax
            Mov   Eax,01010101h*Typ_Video1
Align 10h
@@1:        Mov   [Di],Eax
            Add   Di,4
            Dec   Cx
            Jnz   @@1

@@1a:       Mov   Cx,[CharsetSize]
            Shr   Cx,2
            Jz    @@2a
            Mov   Ds,[Charsetseg]
            Mov   Di,[Charsetofs]
            Cmp   [Byte Di],Typ_Norm
            Jne   @@2a
            Mov   Eax,01010101h*Typ_Video3
Align 10h
@@2:        Cmp   [Dword Di],01010101h*Typ_Norm
            Jne   @@2b
            Mov   [Di],Eax
@@2b:       Add   Di,4
            Dec   Cx
            Jnz   @@2

@@2a:       Mov   Cx,[HiresSize]
            Shr   Cx,2
            Jz    @@3a
            Mov   Ds,[Hiresseg]
            Mov   Di,[Hiresofs]
            Mov   Eax,01010101h*Typ_Video4
Align 10h
@@3:        Mov   [Di],Eax
            Add   Di,4
            Dec   Cx
            Jnz   @@3

@@3a:       Pop   Ds
            Mov   [Byte Gs:1],Typ_0001
            Call  Sethotsprite
            Ret
; ---------------------------------------------------------------------------
Videoaddr:  Mov   Al,[Fs:0DD00h]
            Test  Al,1
            Jz    @@1
            Cmp   Di,1000h
            Jb    @@1
            Cmp   Di,2000h
            Jae   @@1
            Add   Di,0D000h-1000h
            Shr   Di,4
            Add   Di,[Dromdirect]
            Mov   Es,Di
            Mov   Di,0001h       ; HACK!!!
            Mov   Ds,[Layoutseg]
            Ret
@@1:        Push  Ax
            Xor   Al,3
            Shl   Ax,14
            Or    Di,Ax
            Cmp   Di,0A000h
            Jb    @@2
            Cmp   Di,0C000h
            Jb    @@3
            Cmp   Di,0D000h
            Jb    @@2
            Cmp   Di,0E000h
            Jb    @@4
            Mov   Ds,[Eramlayout]
            Mov   Ax,Di
            Shr   Ax,4
            Add   Ax,[Eramdirect]
            Mov   Es,Ax
            Pop   Ax
            Ret
@@2:        Mov   Ds,[Layoutseg]
            Mov   Ax,Di
            Shr   Ax,4
            Add   Ax,[Ramseg]
            Mov   Es,Ax
            Pop   Ax
            Ret
@@3:        Mov   Ds,[Aramlayout]
            Mov   Ax,Di
            Shr   Ax,4
            Add   Ax,[Aramdirect]
            Mov   Es,Ax
            Pop   Ax
            Ret
@@4:        Mov   Ds,[Dramlayout]
            Mov   Ax,Di
            Shr   Ax,4
            Add   Ax,[Dramdirect]
            Mov   Es,Ax
            Pop   Ax
            Ret
; ---------------------------------------------------------------------------
Videoremap: Mov   Di,Fs
            Add   Di,0D800h/10h
            Mov   [Colourbase],Di
            Mov   [ScreenSize],0
            Mov   [CharsetSize],0
            Mov   [HiresSize],0
            Push  Ds
            Mov   Di,[Fs:0D018h]
            And   Di,11110000b
            Shl   Di,10-4
            Call  Videoaddr
            Mov   [Screenbase],Es
            Mov   [Screenseg],Ds
            Mov   [Screenofs],Di
            Pop   Ds
            Mov   Al,[Fs:0D011h]
            Test  Al,00010000b
            Je    @@Blank
            Test  Al,00100000b
            Jne   @@Hires
; -------------------------------------
@@Char:     Mov   [Crtmode],Crt_Char
            Mov   [ScreenSize],1000d

            Push  Ds
            Mov   Di,[Fs:0D018h]
            And   Di,000Eh
            Shl   Di,11-1
            Call  Videoaddr
            Mov   [Charsetbase],Es
            Mov   [Charsetseg],Ds
            Mov   [Charsetofs],Di
            Mov   [CharsetSize],0800h
            Pop   Ds

            Test  [Byte Fs:0D011h],01000000b
            Jnz   @@Chare
            Test  [Byte Fs:0D016h],00010000b
            Jnz   @@Charm
            Jmp   Videoremapsprite
@@Chare:    Mov   [Crtmode],Crt_Chare
            Mov   [CharsetSize],0200h
            Jmp   Videoremapsprite
@@Charm:    Mov   [Crtmode],Crt_Charm
            Jmp   Videoremapsprite

@@Blank:    Mov   [Crtmode],Crt_Blank
            Ret

@@Hires:    Mov   [Crtmode],Crt_Hires
            Push  Ds
            Mov   [ScreenSize],1000d
            Mov   Di,[Fs:0D018h]
            And   Di,00001000b
            Shl   Di,13-3
            Call  Videoaddr
            Mov   [Hiresbase],Es
            Mov   [Hiresseg],Ds
            Mov   [Hiresofs],Di
            Mov   [HiresSize],8000d
            Pop   Ds
            Test  [Byte Fs:0D016h],00010000b
            Jnz   @@Hiresm
            Jmp   Videoremapsprite
@@Hiresm:   Mov   [Crtmode],Crt_Hiresm
            Jmp   Videoremapsprite
; ---------------------------------------------------------------------------
Videoremapsprite:
            Mov   Bl,7
            Push  Ds
@@1:        Mov   Es,[Screenbase]
            Movzx Di,[Byte Es:03F8h+Bx]
            Shl   Di,6
            Call  Videoaddr
            Add   Bx,Bx
            Mov   [Spritebase+Bx],Es
            Mov   [Spriteseg+Bx],Ds
            Mov   [Spriteofs+Bx],Di
            Shr   Bx,1
            Dec   Bl
            Jns   @@1
            Pop   Ds
            Ret
; ---------------------------------------------------------------------------
Clearhotsprite:
            Push  Cx
            Mov   Bx,7
@@1:        Bt    [Word Fs:0D015h],Bx
            Jnc   @@2
            Add   Bx,Bx
            Mov   Es,[Spriteseg+Bx]
            Mov   Di,[Spriteofs+Bx]
            Mov   Cx,63
@@3:        Cmp   [Byte Es:Di],Typ_Video6
            Jne   @@4
            Mov   [Byte Es:Di],Typ_Norm
@@4:        Inc   Di
            Dec   Cx
            Jnz   @@3
            Shr   Bl,1
@@2:        Dec   Bl
            Jns   @@1
            Pop   Cx
            Ret
; ---------------------------------------------------------------------------
Sethotsprite:
            Push  Cx
            Mov   Bx,7
@@1:        Bt    [Word Fs:0D015h],Bx
            Jnc   @@2
            Add   Bx,Bx
            Mov   Es,[Spriteseg+Bx]
            Mov   Di,[Spriteofs+Bx]
            Mov   Cx,63
@@3:        Cmp   [Byte Es:Di],Typ_Norm
            Jne   @@4
            Mov   [Byte Es:Di],Typ_Video6
@@4:        Inc   Di
            Dec   Cx
            Jnz   @@3
            Shr   Bl,1
@@2:        Dec   Bl
            Jns   @@1
            Pop   Cx
            Ret

; ---------------------------------------------------------------------------
Evendata
V1Table     Dw    V1Blank,V1Char,V1Charm,V1Chare,V1Hires,V1Hiresm

St_Video1:  Cmp   Al,[Di]                  ; Store in text memory
            Je    V1Blank

            Mov   [Di],Al
            And   Di,03FFh
            Mov   Bx,[Crtmode]
            Jmp   [V1Table+Bx]
; -------------------------------------
V1Blank:    Jmp   Next
; -------------------------------------
V1Char:     Push  Ax 
            push  Bx 
            push  Cx 
            push  Dx 
            push  Ds 
            push  Fs
            Mov   Ds,[Videoseg]
            Mov   Fs,[Colourbase]
            Mov   Cl,[Fs:Di]
            Mov   Ch,0
V1Char1:    And   Cl,0Fh
            Or    Cl,10h
            Mov   Fs,[Screenbase]
            Mov   Bl,[Fs:Di]
            Shl   Bx,3
            Mov   Fs,[Charsetbase]
            Add   Di,Di
            Mov   Di,[Remap1000+Di]
            Call  Showchar
            Pop   Fs 
            pop   Ds 
            pop   Dx 
            pop   Cx 
            pop   Bx 
            pop   Ax
            Jmp   Next
; -------------------------------------
V1Charm:    Push  Ax 
            push  Bx 
            push  Cx 
            push  Dx 
            push  Ds 
            push  Fs
            Mov   Ds,[Videoseg]
            Mov   Fs,[Colourbase]
            Mov   Cl,[Fs:Di]
            Mov   Ch,0
            Test  Cl,08h
            Jz    V1Char1
            And   Cl,07h
            Mov   Fs,[Screenbase]
            Mov   Bl,[Fs:Di]
            Shl   Bx,3
            Mov   Fs,[Charsetbase]
            Add   Di,Di
            Mov   Di,[Remap1000+Di]
            Mov   Dx,0605h
            Call  Showcharm
            Pop   Fs 
            pop   Ds 
            pop   Dx 
            pop   Cx 
            pop   Bx 
            pop   Ax
            Jmp   Next
; -------------------------------------
V1Chare:    Jmp   Next
; -------------------------------------
V1Hires:    Push  Ax 
            push  Bx 
            push  Cx 
            push  Dx 
            push  Ds 
            push  Fs
            Mov   Ds,[Videoseg]
            Mov   Fs,[Screenbase]
            Mov   Cl,[Fs:Di]
            Mov   Ch,Cl
            Shr   Cl,4
            And   Cx,0F0Fh
            Or    Cx,1010h
            Mov   Fs,[Hiresbase]
            Mov   Bx,Di
            Shl   Bx,3
            Add   Di,Di
            Mov   Di,[Remap1000+Di]
            Call  Showchar
            Pop   Fs 
            pop   Ds 
            pop   Dx 
            pop   Cx 
            pop   Bx 
            pop   Ax
            Jmp   Next
; -------------------------------------
V1Hiresm:
Showhimul:
            Push  Ax 
            push  Bx 
            push  Cx 
            push  Dx 
            push  Ds 
            push  Fs
            Mov   Ds,[Videoseg]
            Mov   Fs,[Screenbase]
            Mov   Dl,[Fs:Di]
            Mov   Dh,Dl
            Shr   Dl,4
            And   Dx,0F0Fh
            Or    Dx,1010h
            Mov   Fs,[Colourbase]
            Mov   Cl,[Fs:Di]
            And   Cx,000Fh
            Or    Cl,10h
            Mov   Fs,[Hiresbase]
            Mov   Bx,Di
            Shl   Bx,3
            Add   Di,Di
            Mov   Di,[Remap1000+Di]
            Call  Showcharm
            Pop   Fs 
            pop   Ds 
            pop   Dx 
            pop   Cx 
            pop   Bx 
            pop   Ax
            Jmp   Next

; ---------------------------------------------------------------------------
Evendata
V2Table     Dw    V21,St_Video1,St_Video1,St_Video1,V21,St_Video1

St_Video2:  And   Al,0Fh               ; Store in colour memory (4 bits)
            Cmp   Al,[Di]
            Je    V22
            Mov   Bx,[Crtmode]
            Jmp   [V2Table+Bx]

V21:        Mov   [Di],Al
V22:        Jmp   Next
; ---------------------------------------------------------------------------
Evendata
V3Table     Dw    V31,V3Char,V3Charm,V3Chare,V31,V31

St_Video3:  Cmp   Al,[Di]              ; Store in character set
            Je    V31
            Mov   [Di],Al
            Mov   Bx,[Crtmode]
            Jmp   [V3Table+Bx]
V31:        Jmp   Next
; -------------------------------------
V3Charm:
V3Chare:    Call  Flagrefresh
            Jmp   Next
; -------------------------------------
V3Char:     And   Di,07FFh
            Mov   Bx,Di
            Shr   Bx,3
            And   Di,7
            Push  Ax 
            push  Cx 
            push  Si 
            push  Ds 
            push  Fs
            Mov   Ds,[Videoseg]
            Mov   Es,[Colourbase]
            Mov   Fs,[Screenbase]
            Mov   Si,0
@@Char1:    Cmp   [Fs:Si],Bl
            Jne   @@Char2
            Mov   Cl,[Es:Si]
            And   Cl,0Fh
            Or    Cl,10h
            Push  Si 
            push  Di
            Add   Si,Si
            Add   Di,Di
            Mov   Si,[Remap1000+Si]
            Add   Si,[Mul320+Di]
@@Char3:    Mov   Ah,0
            Rol   Al,1
            Jnc   @@Char4
            Mov   Ah,Cl
@@Char4:    Mov   [Si],Ah
            Inc   Si
            Test  Si,7
            Jne   @@Char3
            Pop   Di 
            pop   Si
@@Char2:    Inc   Si
            Cmp   Si,[ScreenSize]
            Jne   @@Char1
            Pop   Fs 
            pop   Ds 
            pop   Si 
            pop   Cx 
            pop   Ax
            Jmp   Next
; ---------------------------------------------------------------------------
St_Video4:  Cmp   Al,[Di]              ; Store in hires screen
            Je    @@1
            Mov   [Di],Al
            And   Di,1FFFh
            Cmp   [Crtmode],Crt_Hiresm
            Je    @@M1
            Push  Cx 
            push  Ds
            Mov   Ds,[Videoseg]
            Mov   Bx,Di
            Shr   Di,3
            Mov   Es,[Screenbase]
            Mov   Cl,[Es:Di]
            Mov   Ch,Cl
            Shr   Cl,4
            And   Cx,0F0Fh
            Or    Cx,1010h
            Add   Di,Di
            Mov   Di,[Remap1000+Di]
            And   Bx,7
            Add   Bx,Bx
            Add   Di,[Mul320+Bx]
@@2:        Add   Al,Al
            Jc    @@3
            Mov   [Di],Ch
            Inc   Di
            Test  Di,7
            Jne   @@2
@@4:        Pop   Ds 
            pop   Cx
@@1:        Jmp   Next
@@3:        Mov   [Di],Cl
            Inc   Di
            Test  Di,7
            Jne   @@2
            Jmp   @@4
@@M1:       Shr   Di,3
            Jmp   Showhimul
; ---------------------------------------------------------------------------
St_Video5:  Cmp   Al,[Di]              ; Store in sprite picture pointer
            Je    @@1
            Mov   [Di],Al
            Mov   Bx,Di
            And   Bx,7
            Push  Bx
            Call  Clearhotsprite
            Call  Videoremapsprite
            Call  Sethotsprite
            Pop   Bx
            Bt    [Word Fs:0D015h],Bx
            Jnc   @@1
            Bts   [Word Sprite_Update],Bx
            Bts   [Word Sprite_Reimage],Bx
@@1:        Jmp   Next
; ---------------------------------------------------------------------------
V6TABLE     Dw    V6Blank,V6Char,V6Charm,V6Char,V6Hires,V6Hiresm

St_Video6:  Cmp   Al,[Di]              ; Store in sprite picture
            Je    @@1
            Push  Ax
            Mov   Ax,Di
            And   Ax,3FFFh
            Shr   Ax,6
            Mov   Bl,7
            Mov   Es,[Screenbase]
@@2:        Cmp   Al,[Es:3F8h+Bx]
            Stc
            Je    @@3
            Clc
@@3:        Rcl   Ah,1
            Dec   Bl
            Jns   @@2
            And   Ah,[Fs:0D015h]
            Or    [Sprite_Update],Ah
            Or    [Sprite_Reimage],Ah
            Pop   Ax
            Mov   [Di],Al
@@1:        Jmp   Next
; ---------------------------------------------------------------------------
Snapshot:   Cmp   [Video_Lock],1
            Je    @@2
            Mov   Ds,[Videoseg]
            Xor   Di,Di
            Mov   Bx,[Crtmode]
            Call  [V6TABLE+Bx]
            Mov   Fs,[Iodirect]
            Mov   [Word Fs:0D01Eh],0
            Mov   [Sprite_Shown],0
            Mov   [Sprite_Update],11111111b
            Mov   [Sprite_Reimage],11111111b
            Jmp   Showsprites
@@2:        Ret
; -------------------------------------
V6Char:     Mov   Ch,0
            Mov   Bp,0
            Mov   Es,[Screenbase]
            Mov   Fs,[Charsetbase]
            Mov   Gs,[Colourbase]
@@Char2:    Mov   Al,40
@@Char1:    Mov   Cl,[Gs:Bp]
            And   Cl,0Fh
            Or    Cl,10h
            Mov   Bl,[Es:Bp]
            Shl   Bx,3
            Call  Showchar
            Mov   Bh,0
            Inc   Bp
            Dec   Al
            Jne   @@Char1
            Add   Di,7*320d
            Cmp   Bp,[ScreenSize]
            Jne   @@Char2
            Ret
; -------------------------------------
V6Charm:    Mov   Ch,0
            Mov   Dx,0605h
            Mov   Bp,0
            Mov   Es,[Screenbase]
            Mov   Fs,[Charsetbase]
            Mov   Gs,[Colourbase]
@@Charm2:   Mov   Al,40
@@Charm1:   Mov   Cl,[Gs:Bp]
            And   Cl,0Fh
            Or    Cl,10h
            Mov   Bl,[Es:Bp]
            Shl   Bx,3
            Test  Cl,08h
            Jnz   @@Charm3
            Call  Showchar
@@Charm4:   Mov   Bh,0
            Inc   Bp
            Dec   Al
            Jne   @@Charm1
            Add   Di,7*320d
            Cmp   Bp,[ScreenSize]
            Jne   @@Charm2
            Ret
@@Charm3:   And   Cl,11110111b
            Call  Showcharm
            Jmp   @@Charm4
; -------------------------------------
V6Blank:    Mov   Eax,08080808h
            Mov   Cx,320*200/4
@@Blank1:   Mov   [Di],Eax
            Add   Di,4
            Dec   Cx
            Jne   @@Blank1
            Ret
; -------------------------------------
V6Hires:    Mov   Fs,[Hiresbase]
            Mov   Es,[Screenbase]
            Xor   Bx,Bx
            Mov   Bp,Bx
@@Hires1:   Mov   Ch,[Es:Bp]
            Mov   Cl,Ch
            Shr   Cl,4
            And   Cx,0F0Fh
            Or    Cx,1010h
            Mov   Di,Bp
            Mov   Di,[Remap1000+Di+Bp]
            Call  Showchar
            Inc   Bp
            Cmp   Bp,1000d
            Jne   @@Hires1
            Ret
; -------------------------------------
V6Hiresm:   Mov   Ch,0
            Mov   Fs,[Hiresbase]
            Mov   Es,[Screenbase]
            Mov   Gs,[Colourbase]
            Xor   Bx,Bx
            Mov   Bp,Bx
@@Hiresm1:  Mov   Dh,[Es:Bp]
            Mov   Dl,Dh
            Shr   Dl,4
            And   Dx,0F0Fh
            Or    Dx,1010h
            Mov   Cl,[Gs:Bp]
            And   Cl,0Fh
            Or    Cl,10h
            Mov   Di,Bp
            Mov   Di,[Remap1000+Di+Bp]
            Call  Showcharm
            Inc   Bp
            Cmp   Bp,1000d
            Jne   @@Hiresm1
            Ret
; ---------------------------------------------------------------------------
; Fs:Bx   : Character data pointer
; Ds:Di   : Regen pointer
; Ch      : Colour for 0s
; Cl      : Colour for 1s
Align 10h
Showchar:   Mov   Ah,[Fs:Bx]
@@1:        Add   Ah,Ah
            Jc    @@2
            Mov   [Byte Di],Ch
            Inc   Di
            Test  Di,7
            Jne   @@1
            Add   Di,320d-8
            Inc   Bx
            Test  Bl,7
            Jne   Showchar
            Sub   Di,8*320d-8
            Ret
            Jmp   @@3
@@2:        Mov   [Di],Cl
@@3:        Inc   Di
            Test  Di,7
            Jne   @@1
            Add   Di,320d-8
            Inc   Bx
            Test  Bl,7
            Jne   Showchar
            Sub   Di,8*320d-8
            Ret
; ---------------------------------------------------------------------------
; Fs:Bx   : Character data pointer
; Ds:Di   : Regen pointer
; Ch      : Colour for 00s
; Cl      : Colour for 11s
; dh      : Colour for 10s
; dl      : Colour for 01s
Align 10h
Showcharm:  Mov   Ah,[Fs:Bx]
@@1:        Add   Ah,Ah
            Jc    @@2
            Js    @@3
            Mov   [Di],Ch    ; 00
            Mov   [Di+1],Ch
@@0:        Add   Di,2
            Add   Ah,Ah
            Test  Di,7
            Jne   @@1
            Add   Di,320d-8
            Inc   Bx
            Test  Bl,7
            Jne   Showcharm
            Sub   Di,8*320d-8
            Ret
@@2:        Js    @@4
            Mov   [Di],Dh    ; 10
            Mov   [Di+1],Dh
            Jmp   @@0
@@3:        Mov   [Di],Dl    ; 01
            Mov   [Di+1],Dl
            Jmp   @@0
@@4:        Mov   [Di],Cl    ; 11
            Mov   [Di+1],Cl
            Jmp   @@0
; ---------------------------------------------------------------------------
Spriteengine:
Assume Ds:Emulator
            Sub   Ax,Offset @@4
            Mov   [Word @@6+1],Ax
            Mov   Cx,[Sprite_X+Di]
            Mov   Dx,[Sprite_Y+Di]
            Mov   Si,[Sprite_ImagePtr+Di]
            Mov   Es,[Videoseg]
            Mov   Ah,[Sprite_Syb+Bx]
@@2:        Cmp   Dx,200
            Jae   @@3
            Mov   Di,Dx
            Add   Di,Di
            Mov   Di,[Mul320+Di]
            Add   Di,Cx
@@6:        Call  @@6
@@4:        Mov   Di,Bx
            Sub   Cx,[Sprite_Sxw+Di+Bx]
            Jmp   @@5
@@3:        Mov   Di,Bx
            Add   Si,[Sprite_Sxw+Di+Bx]
@@5:        Inc   Dx
            Dec   Ah
            Jne   @@2
            Ret
Assume Ds:Nothing
; ---------------------------------------------------------------------------
Reshowsprites:
            ;Mov   [Word Fs:0D01Eh],0
            Mov   Bl,7
@@1:        Bt    [Word Sprite_Shown],Bx
            Jnc   @@2
            Bt    [Word Sprite_Update],Bx
            Jc    @@2
            Call  Reshowsprite
@@2:        Dec   Bl
            Jns   @@1
; ---------------------------------------------------------------------------
Showsprites:Mov   Bx,7
@@1:        Bt    [Word Sprite_Update],Bx
            Jnc   @@2
            Call  Hidesprite
@@2:        Dec   Bl
            Jns   @@1
            Mov   Bl,7
@@3:        Btr   [Word Sprite_Update],Bx
            Jnc   @@4
            Call  Showsprite
@@4:        Dec   Bl
            Jns   @@3
            Ret
; ---------------------------------------------------------------------------
Evendata
Norms     Dw    Norm,Normx,Normy,Normxy
Multis    Dw    Multi,Multix,Multiy,Multixy
Ysteps    Db    21 Dup (0,0,24)
Xysteps   Db    21 Dup (0,0,2*24)

Reimagesprite:
            Btr   [Word Sprite_Reimage],Bx
            Jnc   @@1
            Push  Ds 
            push  Ax 
            push  Bx 
            push  Cx 
            push  Dx 
            push  Si 
            push  Bp
            Mov   Di,Bx
            Mov   Al,[Fs:0D01Dh]
            Mov   [Sprite_Expx],Al
            Bt    Ax,Bx
            Mov   Cl,0
            Adc   Cl,Cl
            Mov   Al,24
            Shl   Al,Cl
            Mov   [Sprite_Sxb+Bx],Al
            Mov   [Byte Sprite_Sxw+Di+Bx],Al
            Mov   Al,[Fs:0D017h]
            Mov   [Sprite_Expy],Al
            Bt    Ax,Bx
            Mov   Cl,0
            Adc   Cl,Cl
            Mov   Al,21
            Shl   Al,Cl
            Mov   [Sprite_Syb+Bx],Al
            Mov   [Byte Sprite_Syw+Di+Bx],Al

            Mov   Si,0
            Bt    [Word Sprite_Expy],Bx
            Adc   Si,Si
            Bt    [Word Sprite_Expx],Bx
            Adc   Si,Si
            Add   Si,Si
            Mov   Bp,[Norms+Si]
            Bt    [Word Fs:0D01Ch],Bx
            Jnc   @@3
            Mov   Bp,[Multis+Si]
@@3:        Mov   Si,Bx
            Add   Si,Bx
            Mov   Es,[Spritebase+Si]
            Mov   Di,0
            Mov   Si,[Sprite_ImagePtr+Si]
            Push  Cs
            Pop   Ds
            Mov   Dl,Bl
            Mov   Dh,Bl
            Add   Bl,30h
            Add   Dx,2838h
            Xor   Ecx,Ecx
            Mov   Ah,Cl

@@2:        Mov   Al,[Es:Di]
            Call  Bp
            Inc   Di
            Cmp   Di,21*3
            Jne   @@2
            Pop   Bp 
            pop   Si 
            pop   Dx 
            pop   Cx 
            pop   Bx 
            pop   Ax 
            pop   Ds
@@1:        Ret
; -------------------------------------
Norm:     Mov   [Si],Ecx
            Mov   [Si+4],Ecx
Rept 8      
Local Over
            Add   Al,Al
            Jnc   Over
            Mov   [Si],Bl
Over:     Inc   Si
Endm
            Ret
; -------------------------------------
Normx:    Mov   [Si],Ecx
            Mov   [Si+4],Ecx
            Mov   [Si+8],Ecx
            Mov   [Si+12],Ecx
Rept 8
Local Over
            Add   Al,Al
            Jnc   Over
            Mov   [Si],Bl
            Mov   [Si+1],Bl
Over:     Add   Si,2
Endm
            Ret
; -------------------------------------
Normy:    Mov   [Si],Ecx
            Mov   [Si+4],Ecx
            Mov   [Si+24],Ecx
            Mov   [Si+24+4],Ecx
Rept 8      
Local Over
            Add   Al,Al
            Jnc   Over
            Mov   [Si],Bl
            Mov   [Si+24],Bl
Over:       Inc   Si
Endm
            Mov   Al,[Ysteps+Di]
            Add   Si,Ax
            Ret
; -------------------------------------
Normxy:   Mov   [Si],Ecx
            Mov   [Si+4],Ecx
            Mov   [Si+8],Ecx
            Mov   [Si+12],Ecx
            Mov   [Si+2*24],Ecx
            Mov   [Si+2*24+4],Ecx
            Mov   [Si+2*24+8],Ecx
            Mov   [Si+2*24+12],Ecx
Rept 8
Local Over
            Add   Al,Al
            Jnc   Over
            Mov   [Si],Bl
            Mov   [Si+1],Bl
            Mov   [Si+2*24],Bl
            Mov   [Si+2*24+1],Bl
Over:       Add   Si,2
Endm
            Mov   Al,[Xysteps+Di]
            Add   Si,Ax
            Ret
; -------------------------------------
Multi:    Mov   [Si],Ecx
            Mov   [Si+4],Ecx
Rept 4
Local x1x,x00,x10,x11
            Add   Al,Al
            Jc    x1x
            Add   Al,Al
            Jnc   x00
            Mov   [Si],Dl
            Mov   [Si+1],Dl
            Jmp   x00
x1x:        Add   Al,Al
            Jnc   x10
x11:        Mov   [Si],Dh
            Mov   [Si+1],Dh
            Jmp   x00
x10:        Mov   [Si],Bl
            Mov   [Si+1],Bl
x00:       Add   Si,2
Endm
            Ret
; -------------------------------------
Multix:   Mov   [Si],Ecx
            Mov   [Si+4],Ecx
            Mov   [Si+8],Ecx
            Mov   [Si+12],Ecx
Rept 4
Local x1x,x00,x10,x11
            Add   Al,Al
            Jc    x1x
            Add   Al,Al
            Jnc   x00
            Mov   [Si],Dl
            Mov   [Si+1],Dl
            Mov   [Si+2],Dl
            Mov   [Si+3],Dl
            Jmp   x00
x1x:        Add   Al,Al
            Jnc   x10
x11:        Mov   [Si],Dh
            Mov   [Si+1],Dh
            Mov   [Si+2],Dh
            Mov   [Si+3],Dh
            Jmp   x00
x10:        Mov   [Si],Bl
            Mov   [Si+1],Bl
            Mov   [Si+2],Bl
            Mov   [Si+3],Bl
x00:       Add   Si,4
Endm
            Ret
; ---------------------------------------------------------------------------
Multiy:   Mov   [Si],Ecx
            Mov   [Si+4],Ecx
            Mov   [Si+24],Ecx
            Mov   [Si+24+4],Ecx
Rept 4
Local x1x,x00,x10,x11
            Add   Al,Al
            Jc    x1x
            Add   Al,Al
            Jnc   x00
            Mov   [Si],Dl
            Mov   [Si+1],Dl
            Mov   [Si+24],Dl
            Mov   [Si+24+1],Dl
            Jmp   x00
x1x:        Add   Al,Al
            Jnc   x10
x11:        Mov   [Si],Dh
            Mov   [Si+1],Dh
            Mov   [Si+24],Dh
            Mov   [Si+24+1],Dh
            Jmp   x00
x10:        Mov   [Si],Bl
            Mov   [Si+1],Bl
            Mov   [Si+24],Bl
            Mov   [Si+24+1],Bl
x00:       Add   Si,2
Endm
            Mov   Al,[Ysteps+Di]
            Add   Si,Ax
            Ret
; -------------------------------------
Multixy:  Mov   [Si],Ecx
            Mov   [Si+4],Ecx
            Mov   [Si+8],Ecx
            Mov   [Si+12],Ecx
            Mov   [Si+2*24],Ecx
            Mov   [Si+2*24+4],Ecx
            Mov   [Si+2*24+8],Ecx
            Mov   [Si+2*24+12],Ecx
Rept 4
Local x1x,x00,x10,x11
            Add   Al,Al
            Jc    x1x
            Add   Al,Al
            Jnc   x00
            Mov   [Si],Dl
            Mov   [Si+1],Dl
            Mov   [Si+2],Dl
            Mov   [Si+3],Dl
            Mov   [Si+2*24],Dl
            Mov   [Si+2*24+1],Dl
            Mov   [Si+2*24+2],Dl
            Mov   [Si+2*24+3],Dl
            Jmp   x00
x1x:        Add   Al,Al
            Jnc   x10
x11:        Mov   [Si],Dh
            Mov   [Si+1],Dh
            Mov   [Si+2],Dh
            Mov   [Si+3],Dh
            Mov   [Si+2*24],Dh
            Mov   [Si+2*24+1],Dh
            Mov   [Si+2*24+2],Dh
            Mov   [Si+2*24+3],Dh
            Jmp   x00
x10:        Mov   [Si],Bl
            Mov   [Si+1],Bl
            Mov   [Si+2],Bl
            Mov   [Si+3],Bl
            Mov   [Si+2*24],Bl
            Mov   [Si+2*24+1],Bl
            Mov   [Si+2*24+2],Bl
            Mov   [Si+2*24+3],Bl
x00:       Add   Si,4
Endm
            Mov   Al,[Xysteps+Di]
            Add   Si,Ax
            Ret
; -------------------------------------
Hidesprite: Btr   [Word Fs:0D01Eh],Bx
            Btr   [Word Fs:0D01Fh],Bx
            Btr   [Word Sprite_Shown],Bx
            Jnc   @@1
            Push  Ds
            Pusha
            Mov   Ax,Cs
            Mov   Ds,Ax
Assume Ds:Emulator
            Mov   Di,Bx
            Add   Di,Bx
            Mov   Ax,Offset @@6
            Call  Spriteengine
            Popa
            Pop   Ds
@@1:        Ret

@@6:        Mov   Dh,[Sprite_Sxb+Bx]                ; Hide
@@6a:       Cmp   Cx,320
            Jae   @@6b
            Mov   Al,[Es:Di]
            Cmp   Al,[Si]
            Jne   @@6b
            Or    Al,Al
            Je    @@6b
            Mov   Al,[Si+Sprite_Saveofs]
            Test  Al,00100000b
            Jne   @@6b
            Mov   [Es:Di],Al
@@6b:       Inc   Cx
            Inc   Si
            Inc   Di
            Dec   Dh
            Jne   @@6a
            Ret
Assume Ds:Nothing
; ---------------------------------------------------------------------------
Selfcode    dw 0

Reshowsprite:Inc  Bh
Showsprite: Mov   Di,Offset @@6
            Or    Bh,Bh
            Je    @@2
            Mov   Di,Offset @@7
            Dec   Bh
@@2:        Bt    [Word Fs:0D015h],Bx
            Jnc   @@1
            Mov   [SelfCode] ,Di
            Call  Reimagesprite
            Push  Ds
            Pusha
            Mov   Ax,Cs
            Mov   Ds,Ax
Assume Ds:Emulator
            Mov   Di,Bx
            Add   Di,Bx
            Bts   [Word Sprite_Shown],Bx
            Bt    [Word Fs:0D010h],Bx
            Sbb   Ah,Ah
            Neg   Ah
            Mov   Al,[Fs:0D000h+Di]
            Sub   Ax,[Sprite_Dx]
            Mov   [Sprite_X+Di],Ax
            Xor   Ah,Ah
            Mov   Al,[Fs:0D001h+Di]
            Sub   Ax,[Sprite_Dy]
            Mov   [Sprite_Y+Di],Ax

            Mov   Ax, [Selfcode]
            Call  Spriteengine
            Popa
            Pop   Ds
@@1:        Ret

@@6:        Mov   Dh,[Sprite_Sxb+Bx]                ; Simple show
@@6a:       Cmp   Cx,320
            Jae   @@6b
            Cmp   [Si],Bh
            Je    @@6b
            Mov   Al,[Es:Di]
            Mov   [Si+Sprite_Saveofs],Al
            Test  Al,11100000b
            Jne   @@6d
            Test  Al,11111100b
            Je    @@6c
            Bts   [Word Fs:0D01Fh],Bx
@@6c:       Mov   Al,[Si]
            Mov   [Es:Di],Al
@@6b:       Inc   Cx
            Inc   Si
            Inc   Di
            Dec   Dh
            Jne   @@6a
            Ret
@@6d:       And   Al,7
            Bts   [Word Fs:0D01Eh],Bx
            Xchg  Al,Bl
            Bts   [Word Fs:0D01Eh],Bx
            Xchg  Al,Bl
            Jmp   @@6b


@@7:        Mov   Dh,[Sprite_Sxb+Bx]                ; Reshow
@@7a:       Cmp   Cx,320
            Jae   @@7b
            Cmp   [Si],Bh
            Je    @@7b
            Mov   Al,[Es:Di]
            Test  Al,11100000b
            Jne   @@7d
            Test  Al,11111100b
            Je    @@7c
            Bts   [Word Fs:0D01Fh],Bx
@@7c:       Mov   [Si+Sprite_Saveofs],Al
            Mov   Al,[Si]
            Mov   [Es:Di],Al
@@7b:       Inc   Cx
            Inc   Si
            Inc   Di
            Dec   Dh
            Jne   @@7a
            Ret
@@7d:       And   Al,7
            Cmp   Al,Bl
            Je    @@7b
            Bts   [Word Fs:0D01Eh],Bx
            Xchg  Al,Bl
            Bts   [Word Fs:0D01Eh],Bx
            Xchg  Al,Bl
            Jmp   @@7b

Assume Ds:Nothing
; ---------------------------------------------------------------------------
